C#ATIA

↑タイトル詐欺 主にCATIA V5 の VBA(最近はPMillマクロとFusion360APIが多い)

「サブツリー」コマンド

マクロで「サブツリーを開く」を行いたい と御質問を頂きました。
結論を先に書くと出来なさそうです。が、その他調べた事を覚書しておきます。

今まで利用した事が無かったのですが、メニューの「表示」内に「サブツリー」が
あるのを知りませんでした。
f:id:kandennti:20180712180236p:plain
試した所、ちょっと不思議な感じがしました。

CATIAを起動し新たにPartを作成した状態では、こんな感じでグレーアウトしてます。
f:id:kandennti:20180712180244p:plain

これを利用する為には、一度コンテキストメニューの「サブツリーを開く」を実行すると
チェックが入った状態で利用できます。
f:id:kandennti:20180712180253p:plain

クリックするとチェックが外れ、全てのサブツリーウィンドウが消えます。
f:id:kandennti:20180712180317p:plain

続いて新たにPartを作ります。
最初は利用できない状態ですが、一度コンテキストメニューの「サブツリーを開く」を実行します。
ここでメニューからではなく、サブツリーウィンドウの×印をクリックし閉じます。
f:id:kandennti:20180712180337p:plain

ここでメニューを見ると、グレーアウトしてます。
f:id:kandennti:20180712180343p:plain

先程とは状態が異なります。

サブツリーウィンドウの×印をクリックした場合は、実際にウィンドウを閉じていて
メニューの「サブツリー」はサブツリーウィンドウ全てを表示/非表示操作しているのだろう
と思われます。
(最初とX印で閉じた場合、表示/非表示に関わらずサブツリーウィンドウが無い為
 コマンド自体が利用できない)

こんな制限付きの「サブツリー」コマンドであれば、こちらで利用可能です。

 '日本語
 CATIA.StartCommand ("サブツリー")
 '英語
 CATIA.StartCommand ("Sub-Trees")

但し、サブツリーウィンドウが開いていても、CATIA.Windows.Countは変化無く
実際に開かれているのか?開かれていないのか? はマクロで判断する事も
難しそうです。(WinAPIでゴリゴリなら出来そうですが)


この「サブツリー」コマンドの存在に気が付いたのは、「表示」-「コマンドリスト」です。
f:id:kandennti:20180712180357p:plain
恐らくライセンスに関係無く、アクティブなワークベンチで利用可能なコマンドのリストを
表示してくれます。
ここで表示されるものであれば StartCommand で利用可能だと思います。

StartCommand は起動している言語に依存していますが、こちらに記載した
コマンドIDを利用すれば、言語依存しないマクロが作れます。
コマンドID - C#ATIA

但し、今回の「サブツリー」コマンドについては、GrabCADにUpしたリストには
入ってませんでした・・・。

子ウィンドウの整列スタイル

御質問頂いた際、正直何のことかわかりませんでした。
が、調べたら理解できました。(最初はパターンの何か? かと思いました)

要は、ここの表示の切り替えをマクロで行いたいと言う事ですよね?
f:id:kandennti:20180712162053p:plain

'CatArrangeStyleテスト
Sub CATMain()

    Call CATIA.Windows.Arrange(CatArrangeStyle.catArrangeCascade)
    CATIA.RefreshDisplay = True
    MsgBox "CatArrangeStyle - catArrangeCascade"
    
    Call CATIA.Windows.Arrange(CatArrangeStyle.catArrangeTiledHorizontal)
    CATIA.RefreshDisplay = True
    MsgBox "CatArrangeStyle - catArrangeTiledHorizontal"
        
    Call CATIA.Windows.Arrange(CatArrangeStyle.catArrangeTiledVertical)
    CATIA.RefreshDisplay = True
    MsgBox "CatArrangeStyle - catArrangeTiledVertical"

End Sub

3つのスタイルを順番に変更します。最小化しているウィンドウは影響無いようです。
又、環境や使用方法次第ですが、RefreshDisplayを入れておかないと
スタイルの変更が間に合わない場合があるかもしれません。
(こちらで試した際、入れないと半分ぐらいしか表示しない状態で
  MsgBoxが出現しました)

CHAI3D

こちら面白そうです。
CHAI3D - Home
こんなのがオープンソースで存在している事を知りませんでした。
と言っても、入力デバイスがうちには無いです。
3Dスキャナはあるんですけどね・・・梱包したまま。

データム化された要素の入っている形状セットの取得

”マクロがPCによって動くものと動かないものがある”と相談を頂きました。
状況が良くわからないので、完全な答えには辿り着けない可能性も有りますが。。。

点を選択後、点の含まれている形状セットの取得部分が問題のようです。

まず、こんなデータを用意しました。
f:id:kandennti:20180704124318j:plain
点1は通常の状態で、点2はデータム化されています。

続いてこんなマクロを作りました。

'catvba
Sub CATMain()
    Dim doc As PartDocument
    Set doc = CATIA.ActiveDocument
    
    Dim sel As Variant ' Selection
    Set sel = doc.Selection
    
    '選択
    Dim msg As String
    msg = "点を選択"
    
    Dim filter As Variant
    filter = Array("Point")
    
    sel.Clear
    Select Case sel.SelectElement2(filter, msg, False)
        Case "Cancel", "Undo", "Redo"
            Exit Sub
    End Select
    
    '選択要素の取得
    Dim point As AnyObject
    Set point = sel.Item(1).value
    
    '結果
    Debug.Print "********"
    Debug.Print "point typename : ", TypeName(point)
    Debug.Print "point.Parent typename : ", TypeName(point.Parent)
    Debug.Print "point.Parent.Parent typename : ", TypeName(point.Parent.Parent)
    Debug.Print "point.Thickness.Parent.Parent typename : ", TypeName(point.Thickness.Parent.Parent)
End Sub

点を選択し、Parentのオブジェクトタイプをイミディエイトウィンドウに表示します。
もう答えは書いているのですが・・・。

GSD要素がデータム化されている場合とされていない場合では、画面上や手動操作では
大きな違いを感じませんが、マクロではかなりの違いが有ります。

このマクロで点1を選択した際の結果はこちら

********
point typename :            HybridShapePointOnPlane
point.Parent typename :     HybridShapes
point.Parent.Parent typename :            HybridBody
point.Thickness.Parent.Parent typename :  HybridBody

質問者さんのコードでは、"point.Parent.Parent" となっており、HybridBodyが
取得できています。

続いて点2を選択した際の結果はこちら

********
point typename :            HybridShapePointExplicit
point.Parent typename :     Parameters
point.Parent.Parent typename :            Part
point.Thickness.Parent.Parent typename :  HybridBody

"point.Parent.Parent" は、HybridBodyではなくPartになります。
そもそも point.Parent が、点1では HybridShapes なのに対し
点2では Parameters になります。

データム化されている・されていないを判断し処理を分けるのも
良いかもしれませんが、共通のプロパティ Thickness を利用すると
処理を分ける必要も無さそうです。

    Dim HybrBody As HybridBody
    Set HybrBody = point.Thickness.Parent.Parent


Thicknessプロパティ は HybridShapeオブジェクトで実装されています。
以前から思うのですが、何故GSD要素に "厚み" が必要なのかな?
(ライセンス無いのでわからないのですが ボリューム?)

デフォルト [コンポーネント/残り代] と異なる設定のツールパス名を取得4

こちらの続きです。
デフォルト [コンポーネント/残り代] と異なる設定のツールパス名を取得3 - C#ATIA

ツールパスのコンテキストメニュー呼び出しに変更し、デフォルトだけではなく任意のツールパスの
設定との比較を出来るようにし、(少しだけ高速化し)こちらの67件目で公開しました。
Tips & Tricks - Page 4 - Autodesk Community

こちらや
thickness set for fixtures - Autodesk Community
こちら
"Toolpath gaps" issue - Autodesk Community
で問題になっている、電極加工時のクランプとの干渉ですが、
僕が行っている方法だとクリヤしているんです。
公開しているのは、その為の確認用のマクロなんです。

ファイルを最小化でオープンしつつ、オープン前のウィンドウをアクティブ化

「パワーコピーのPartファイルを最小化で開きつつ、開く前のアクティブな'ウィンドウをアクティブ状態にする」
と言う内容のご相談を頂きました。

正直な所、どのような操作を想定されているのかが、把握できていない為
目的の状態になっていない可能性もありますが・・・

'vba
Sub CATMain()
    'パワーコピーファイル パス
    Dim PowerCopy_path As String
    PowerCopy_path = "C:\temp\powercopy_part.CATPart"
    
    'パワーコピーファイル オープン前に現在のアクティブな
    'ウィンドウを取得
    Dim BeforeActWin As Window
    Set BeforeActWin = CATIA.ActiveWindow
    
    'パワーコピーファイル オープン
    Dim objPspDoc As PartDocument
    Set objPspDoc = CATIA.Documents.Open(PowerCopy_path)
    
    'パワーコピーファイル のウィンドウ
    Dim ActiveWin As Window
    'Set ActiveWin = CATIA.ActiveWindow
    Set ActiveWin = CATIA.Windows.Item(CATIA.Windows.count)
    
    '最小化
    ActiveWin.WindowState = catWindowStateMinimized
    
    '最初のアクティブなウィンドウをアクティブ
    BeforeActWin.Activate
    
    'ここで何かしらの処理
    Stop
    
    'パワーコピーファイル クローズ
    objPspDoc.Close
End Sub

・ファイルをオープンする前に、現状のアクティブウィンドウを取得しておきます。
  (Set BeforeActWin = CATIA.ActiveWindow)
・ウィンドウの最小化はWindowStateプロパティで可能です。
  (ActiveWin.WindowState = catWindowStateMinimized)

PMillマクロ速度比べ2

こちらの続き? です。
PMillマクロ速度比べ - C#ATIA

週末に思い付いたので、テストしてみました。

〇配列とリスト
PMillには配列とリストがあるのですが、あまり配列は使った事が無いです。
単純にINT型を1~100までの値を持つ両方を作成する時間を
比べてみました。
・配列

//pm2018 macro arrya
function main() {
	call Sw_Start()
	int array lst[] = fill(100,0)
	int i = 0
	foreach idx in lst {
		$lst[i] = $i + 1
		$i = $i + 1
	}
	string time = ''
	call Sw_GetTime($time)
	message info  $time
}

//clock on
function Sw_Start() {
	CLOCK RESET QUIT
	CLOCK ON QUIT	
}

//clock off
function Sw_GetTime(output string out) {
	string $TraceFilePath = macro_path(false) + "\clock.txt"
	string list txts = {}
	ECHO OFF DCPDEBUG UNTRACE COMMAND ACCEPT
	TRACEFILE OPEN $TraceFilePath
	CLOCK OFF QUIT
	CLOCK PRINT QUIT
	TRACEFILE CLOSE
	ECHO ON DCPDEBUG TRACE COMMAND ACCEPT
	
	FILE OPEN $TraceFilePath FOR READ AS Input
	FILE READ $txts FROM Input
	FILE CLOSE Input
	DELETE FILE $TraceFilePath

	$out = $txts[0]
}

結果は4.5秒弱でした。

・リスト
同様の結果を得るだけなのですが、リストを拡張する為のadd_lastメソッドが
遅いのではないかな? と感じていた為です。

//pm2018 macro list
function main() {
	call Sw_Start()
	int list lst = {}
	int i = 0
	foreach s in fill(100,"") {
		$i = add_last($lst, $i+1)
	}
	string time = ''
	call Sw_GetTime($time)
	message info  $time
}
・・・

時間測定の為の関数は同様です。
結果は、2.5秒弱でした。add_lastは遅く無かったです。


〇ThicknessSetValuesのMode取得
ThicknessSetValuesのModeの取得する際、1つのツールパスの16個をまとめて
リストとして取得したいのですが、こんな感じに書くとエラーになります。

	object list tvs = $tp.ThicknessSetValues
	
	string list mode = extract($tvs, 'Mode')

ThicknessSetValuesのModeは、デバッガ上では文字列に見えるのですが、
実際はEnum型の為、"string list" ではNGなんです。
(しかし、マクロではEnum型が使えない)

・ForEach
一個だけの取得では文字列として受け取れるので、直接パラメータの
値を取得してみました。

//pm2018 macro ThicknessSetValues Mode Foreach
function main() {
	call Sw_Start()
	string list mode = {}
	int dmy = 0
	foreach tp in folder('toolpath') {
		object list tvs = $tp.ThicknessSetValues
		$mode = {}
		foreach $tv in $tvs {
			$dmy = add_last($mode, string($tv.Mode))
		}
	}
	string time = ''
	call Sw_GetTime($time)
	message info  $time
}

あるプロジェクトファイルで試した所、結果は8秒前後です。


・join_tokens
Enum型のリストを直接 "string list" としては受け取れない為、
変数に代入する前にJoinし再度tokensし、強引に string list化
しました。(思い付きで試した所、動きました)

//pm2018 macro ThicknessSetValues Mode joint_tokens
function main() {
	call Sw_Start()
	string list mode = {}
	int dmy = 0
	foreach tp in folder('toolpath') {
		object list tvs = $tp.ThicknessSetValues	
		$mode = tokens(join(extract($tvs, 'Mode'),','),',')	
	}
	string time = ''
	call Sw_GetTime($time)
	message info  $time
}
・・・

結果は1秒弱でした。 結構無理やりでも取得できるっぽいです。